"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var InputCode = /** @class */ (function (_super) {
    __extends(InputCode, _super);
    function InputCode(props) {
        var _this = _super.call(this, props) || this;
        _this.textInputCode = null;
        _this.onPressCode = function () {
            if (_this.textInputCode === null)
                return;
            _this.textInputCode.focus();
        };
        _this.onChangeText = function (value) {
            value = value.replace(/[^0-9]/g, '');
            var changed = value !== _this.state.code;
            _this.setState({ code: value });
            if (changed) {
                _this.props.onChangeCode && _this.props.onChangeCode(value);
                if (value.length === _this.props.length) {
                    react_native_1.Keyboard.dismiss();
                    react_native_1.InteractionManager.runAfterInteractions(function () {
                        _this.props.onFullFill && _this.props.onFullFill(value);
                    });
                }
            }
        };
        _this.reset = function () {
            if (_this.textInputCode === null)
                return;
            _this.textInputCode.clear();
            _this.setState({ code: '' });
        };
        _this.focus = function () {
            if (_this.textInputCode === null)
                return;
            react_native_1.InteractionManager.runAfterInteractions(function () {
                _this.textInputCode.focus();
            });
        };
        _this.state = {
            code: '',
        };
        return _this;
    }
    InputCode.prototype.extractCode = function (index) {
        if (this.props.passcode && this.state.code.length - 1 > index) {
            return '*';
        }
        return this.state.code.length <= index ? '' : this.state.code.substr(index, 1);
    };
    InputCode.prototype.render = function () {
        var _this = this;
        var renderItem = function (index) { return (react_1.default.createElement(react_native_1.View, { style: _this.state.code.length === index
                ? __assign({}, styles.codeContainerCaret, _this.props.codeContainerCaretStyle) : __assign({}, styles.codeContainer, _this.props.codeContainerStyle), key: 'input-code-' + index.toString() },
            react_1.default.createElement(react_native_1.Text, { style: __assign({ fontSize: 30 }, _this.props.codeTextStyle) }, _this.extractCode(index)))); };
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(react_native_1.View, { style: this.props.style },
                react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: this.onPressCode, style: { alignItems: 'stretch' }, activeOpacity: 1 },
                    react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', justifyContent: 'space-around' } }, Array(this.props.length)
                        .fill(0)
                        .map(function (item, index) { return renderItem(index); })))),
            react_1.default.createElement(react_native_1.TextInput, { ref: function (ref) {
                    _this.textInputCode = ref;
                }, autoFocus: this.props.autoFocus, keyboardType: "number-pad", caretHidden: true, textContentType: this.props.oneTimeCode ? 'oneTimeCode' : undefined, onChangeText: this.onChangeText, maxLength: this.props.length, style: { fontSize: 0, height: 1, opacity: 0, margin: 0, padding: 0 }, value: this.state.code })));
    };
    InputCode.defaultProps = {
        autoFocus: false,
    };
    return InputCode;
}(react_1.Component));
exports.default = InputCode;
var styles = {
    codeContainer: {
        justifyContent: 'center',
        alignItems: 'center',
        width: 50,
        height: 50,
        borderWidth: 1,
        borderColor: 'gray',
    },
    codeContainerCaret: {
        justifyContent: 'center',
        alignItems: 'center',
        width: 50,
        height: 50,
        borderWidth: 1,
        borderColor: 'gray',
    },
};
//# sourceMappingURL=index.js.map